--[[---------------------------------------------------------------------------
	
	Creator: x[N]ir - #4841
	This work is licensed under the Creative Commons 
	Attribution-NonCommercial-ShareAlike 4.0 International License. 
	License details: http://creativecommons.org/licenses/by-nc-sa/4.0/
	
-----------------------------------------------------------------------------]]

--[[---------------------------------------------------------------------------
	Init
-----------------------------------------------------------------------------]]
if camera then
	print( "\169255000000[ERROR]: Camera Script is already launched !" )
	return
end

--[[---------------------------------------------------------------------------
	Main Table
-----------------------------------------------------------------------------]]
camera = {
	list = {},
}

--[[---------------------------------------------------------------------------
	Files
-----------------------------------------------------------------------------]]
local ROOT = "sys/lua/camera/"
local FILES = {
	"lua/constants.lua",
	"lua/camera.lua",
	"lua/hooks.lua",
	"cfg/config.cfg"
}

-- Loading all files
for _, file in ipairs( FILES ) do
	dofile( ROOT .. file )
end

--[[---------------------------------------------------------------------------
	Hooks
-----------------------------------------------------------------------------]]
local HOOKS = { "startround", "ms100", "hitzone" }

-- Attaching all hooks
for _, hook in ipairs( HOOKS ) do
	addhook( hook, "camera." .. hook )
end

--[[---------------------------------------------------------------------------
	Config File
-----------------------------------------------------------------------------]]
local mapName = map( "name" )

-- Add all cameras
for _, cam in pairs( camera.Locations[ mapName ] or {} ) do
	camera.add( cam.pos, cam.type, cam.rot, cam.laserRange, 
		cam.laserColor, cam.hp, cam.rotDelay, cam.endRot )
end

camera.Locations = nil -- Not needed anymore